﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Collections;

namespace SPProvider
{
    public class Controller
    {

        
        public static DataSet GetProductsList(int appId, string storedPr)
        {
            ImplementationProvider myProvider;
            DataSet ds = null;

            try
            {
                //instance provider
                myProvider = new ImplementationProvider("SYS1", "SQLSERVER");
                myProvider.AddParameter_SQLServer("AppId", appId.ToString(), ParameterDirection.Input);

                ds = myProvider.RunStoredProcedureSQLServer(storedPr, "NA");
                return ds;
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Source + ":" + ex.Message);
            }
        }

        public static int CalculateCapacity(Hashtable inputs, Hashtable inouts, Hashtable outputs, string storedPr)
        {
            ImplementationProvider myProvider;
            int resp = 0;

            try
            {
                //instance provider
                myProvider = new ImplementationProvider("SYS2", "ORACLE");

                foreach (string iname in inputs.Keys)
                {
                    myProvider.AddParameter_Oracle(iname, Convert.ToInt32(inputs[iname]), ParameterDirection.Input);
                }
                foreach (string ioname in inouts.Keys)
                {
                    myProvider.AddParameter_Oracle(ioname, Convert.ToInt32(inouts[ioname]), ParameterDirection.InputOutput);
                }
                foreach (string oname in outputs.Keys)
                {
                    myProvider.AddParameter_Oracle(oname, Convert.ToInt32(outputs[oname]), ParameterDirection.Output);
                }

                resp = myProvider.RunStoredProcedureOracle(storedPr, "NA");
                
                return resp;
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Source + ":" + ex.Message);
            }
        }


    }
}
