﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using System.Configuration;

namespace SPProvider
{
    internal class ImplementationProvider
    {

        protected string _connectionString;
        protected SqlConnection conn = null;
        protected Oracle.DataAccess.Client.OracleConnection connO = null; 
        protected System.Collections.ArrayList parameters = new System.Collections.ArrayList();
  

        internal string ConnectionString
        {
            set { _connectionString = value; }
            get { return _connectionString; }
        }

        internal ImplementationProvider(string sKey, string engine)
        {
            //ConnectionString = ConfigurationManager.AppSettings[sKey].ToString();
            
            if (sKey.Equals("SYS2") && engine.Equals("ORACLE"))
            {
                ConnectionString = 
                    "Data Source = (DESCRIPTION = (ADDRESS_LIST = (ADDRESS = (PROTOCOL = TCP)(HOST = myHost)(PORT = myOraclePort)))(CONNECT_DATA = (SERVER = DEDICATED)(SERVICE_NAME = myOracleServiceName))); User Id = myUserDB; Password = myPassword;";
                connO = new Oracle.DataAccess.Client.OracleConnection(this.ConnectionString);
            }
            else
            {
                ConnectionString = 
                    "Persist Security Info=True;Current Language=us_english;" +
                    "Data Source=myDBInstance;Initial Catalog=myDatabase;User ID=myLogin;Password=myPassword";
                conn = new SqlConnection(this.ConnectionString);
            }
        }

        internal void AddParameter_SQLServer(string sParamName, string sParamValue, ParameterDirection dir)
        {
            SqlParameter param;

            // Requiered SP development team change: pass NULL values not empty strings
            if (sParamValue == "")
                param = new SqlParameter(sParamName, DBNull.Value);
            else
                param = new SqlParameter(sParamName, sParamValue);
            parameters.Add(param);
            param.Direction = dir;
        }

        internal void AddParameter_Oracle(string sParamName, int sParamValue, ParameterDirection dir)
        {
            Oracle.DataAccess.Client.OracleParameter param;

            param = new Oracle.DataAccess.Client.OracleParameter(sParamName, sParamValue);
            
            parameters.Add(param);
            param.Direction = dir;
        }


        internal DataSet RunStoredProcedureSQLServer(string storeprocedure, string tableName)
        {
            SqlCommand comm = new SqlCommand(storeprocedure, conn);
            for (int i = 0; i < parameters.Count; i++)
            {
                comm.Parameters.Add((SqlParameter)parameters[i]);

            }
            comm.CommandType = CommandType.StoredProcedure;

            SqlDataAdapter da = new SqlDataAdapter(comm);

            DataSet ds = new DataSet();
            da.Fill(ds);
            if (ds.Tables.Count > 0)
                ds.Tables[0].TableName = tableName;

            parameters = new System.Collections.ArrayList();
            return ds;
        }

        internal int RunStoredProcedureOracle(string storeprocedure, string tableName)
        {
            int resp = 0;


            Oracle.DataAccess.Client.OracleCommand commO = 
                new Oracle.DataAccess.Client.OracleCommand(storeprocedure, connO);
            for (int i = 0; i < parameters.Count; i++)
            {
                commO.Parameters.Add((Oracle.DataAccess.Client.OracleParameter)parameters[i]);

            }
            commO.CommandType = CommandType.StoredProcedure;

            //try
            //{
                commO.Connection.Open();
                resp = commO.ExecuteNonQuery();
                Oracle.DataAccess.Client.OracleParameter tempParam = commO.Parameters[3];
                resp = Convert.ToInt32(tempParam.Value);
            //}
            //finally
            //{
                commO.Connection.Close();
            //}

            parameters = new System.Collections.ArrayList();
            return resp;
        }


    }
}
